/*
 * Copyright (c) 2017 Akitsugu Komiyama
 * under the MIT License
 */

#pragma once

#include <windows.h>
#include <string>

#include "convert_string.h"
#include "output_debugstream.h"


using namespace std;

#define MACRO_DLL extern "C" __declspec(dllexport) 

//---------------------------------------------------------------------------------------------------
// hwnHidemaru   : Gۂ̃EBhEnh
// pwszIn        : wchar_t* ^ ϊΏۂƂȂĂ镶񂪑SnĂB
// pszParamBuffer: uGۃ}Nfilter֐vœnƂɂȂR̕B
//                ͎ŎRɎŌ߂Ap[^݂Ȃ́B
//                ʏ́u0vƁu1v̕тƂ邱ƂAgParsêŉłǂ낤B
// 
//                Ⴆ΁AGۂ́uSortϊW[v̏ꍇ́A
//                fReverse     = pszParamBuffer[0] == '1' or '0';
//                fIgnoreSpace = pszParamBuffer[1] == '1' or '0';
//                fIgnoreCase  = pszParamBuffer[2] == '1' or '0';
//                fRealNumber  = pszParamBuffer[3] == '1' or '0';
//
//                Ap[^ǂݎ邾ł͂ȂAłƂ\B
//                ł̂́AuL[̋L^vƁAGۃGfB^̃p[^oB
//                L[̍ĐƁAGۃGfB^ŊoĂp[^tĕϊW[Ăяo悤ɂȂA
//                _CAOoɑOƓIŎso悤ɂݏグ邱Ƃ\ɂȂĂ܂B
//
// cbParamBuffer : pszParam̏Gۖ{̑̃obt@[TCYB260B
//---------------------------------------------------------------------------------------------------
using HIDEMARUFILTERFUNC = HGLOBAL(_cdecl *)( HWND hwndHidemaru, const wchar_t* pwszIn, char* pszParamBuffer, int cbParamBuffer);


struct HIDEMARUFILTERINFO {
	UINT                cbStructSize;
	const char*         pszExportName;
	const char*         pszNameJapan;
	const char*         pszNameUs;
	BYTE                chAccel;        // ANZ[^L[
	BYTE                fMustLineUnit;  // sPʂłȂƎsłȂtO
	BYTE                abReserve[2];
};


#define WM_HIDEMARUINFO (WM_USER + 181)

#define HIDEMARUINFO_GETTABWIDTH	0
#define HIDEMARUINFO_GETSTARTCOLUMN 1
#define HIDEMARUINFO_GETSPACETAB	2



// utf16globalցB͉łĂȂ̂ŏGەϊW[p
HGLOBAL utf16_to_hm_filter_global(const wstring& wstr_text);

// ʂ̏̃o[WGۂv`̃o[Wl
int double_ver_to_hm_filter_ver(const double ver);
